'#Reference {B95F03D7-8DC8-4267-A5EC-6E29D9E2AB56}#1.0#0#C:\Winfilm\Samsung\mK1000Sim.exe#FtgMK1000Sim
' MK1000SimXL.bas SIMULATOR VERSION
' FTG Software Associates, Princeton, NJ 2012-2017
' Support: support@ftgsoftware.com

DefInt I-N
DefSng A-H, O-Z
Option Base 1
Option Explicit

'#Uses "ProcessKill.bas"
'
' ****************** Change as required ******************
'
Const Title As String = "Scan vs Temperature"
'
'    Default directory for saving Excel files
Const Directory$ = "c:\Winfilm\MK1000XL\"
'
'    c:\Winfilm\Measure.ini configuration section
Const IniSec$ = "MultiScan"
'
'    Scan method
Const ScanMethod$ = Directory$ & "PE-Lam950.scw"
'
'    Temperature accuracy
Const tDelta! = .05  ' difference between setting and reading
Const tDeriv! = .01  ' difference between two readings

' ********************************************************
'
Dim mK1000 As FtgMK1000Sim.clsBasic

' Following used to change font in dialog box
Const LOGPIXELSY = 90
Const WM_SETFONT = &H30
Declare Function CreateFontA Lib "gdi32" (ByVal nHeight As Long, ByVal nWidth As Long, ByVal nEscapement As Long, ByVal nOrientation As Long, ByVal fnWeight As Long, ByVal fdwItalic As Long, ByVal fdwUnderline As Long, ByVal fdwStrikeOut As Long, ByVal fdwCharSet As Long, ByVal fdwOutputPrecision As Long, ByVal fdwClipPrecision As Long, ByVal fdwQuality As Long, ByVal fdwPitchAndFamily As Long, ByVal lpszFace As String) As Long
Declare Function GetDeviceCaps Lib "gdi32" (ByVal hDC As Long, ByVal nIndex As Long) As Long
Declare Function GetDlgItem Lib "user32" (ByVal hDlg As Long, ByVal nIDDlgItem As Long) As Long
Declare Function GetWindowDC Lib "user32" (ByVal hWnd As Long) As Long
Declare Function ReleaseDC Lib "user32" (ByVal hWnd As Long, ByVal hDC As Long) As Long
Declare Function SendMessageA Lib "user32" (ByVal hWnd As Long, ByVal uMsg As Long, ByVal wParam As Long, ByVal lParam As Long) As Long
Dim hFont As Long, Desc$, Tmin, Tmax, Tdel, mType

Const MeasSec$ = "MK1000Scan"   ' section in MEASURE.ini

Sub Main
    TestFile$(1) = ""
    FileOpen ScanMethod$
    AxesDraw
    KillProcess "mK1000Sim.exe"     ' If server left running we need to remove it
    MainEvents = True               ' Abort command operative
    Set mK1000 = New FtgMK1000Sim.clsBasic
    mK1000.MainShow True
    'Wait 5  ' establish communications, etc.
    If MsgBox("Is the FTG mK1000 Server visible and displaying temperature?", vbYesNo + vbQuestion, Title$) = vbNo Then
        MsgBox "Correct any issues and try again.", vbInformation, Title
        Set mK1000 = Nothing
        KillProcess "mK1000Sim.exe"
        End
    End If

    'Scanning instruments
    If ScanTypes = 1 Or ScanTypes=3  Then
        Select Case MsgBox("Has the 0% baseline scan been completed?", vbYesNoCancel + vbQuestion, Title$)
        Case vbYes
        Case vbNo
            MsgBox "Set instrument for 0% baseline measurement; then click OK", vbInformation, Title
            DataType = 2
            Scan
        Case vbCancel
            End
        End Select
    End If
    If ScanTypes = 2 Or ScanTypes = 3 Then
        Select Case MsgBox("Has the reference scan been completed?", vbYesNoCancel + vbQuestion, Title$)
        Case vbYes
        Case vbNo
            MsgBox "Set instrument for reference measurement; then click OK", vbInformation, Title
            DataType = 3
            Scan
        Case vbCancel
            End
        End Select
    End If
    Select Case MsgBox("Is the sample mounted properly?", vbYesNoCancel + vbQuestion, Title$)
    Case vbNo
        MsgBox "Place sample in position; then click OK", vbInformation, Title
    Case vbCancel
        GoTo Cancelled
    End Select
    DataType = 1    ' sample scan
    Begin Dialog UserDialog 680,216,"MultiScan vs Temperature",.DlgFunc ' %GRID:10,3,1,1
        OptionGroup .MeasType
            OptionButton 210,15,140,18,"&Reflectance",.optRefl
            OptionButton 400,15,160,20,"&Transmittance",.optTrns
        Text 30,63,120,15,"&Description",.lblDesc,1
        TextBox 170,49,410,42,.txtDesc,1
        Text 210,108,40,12,"Min",.lblTmin
        Text 340,108,50,12,"Ma&x",.lblTmax
        Text 470,108,60,12,"Delta",.lblTdel
        Text 20,126,170,15,"Te&mperature Range",.lblTemp,1
        TextBox 210,126,100,21,.txtTmin
        TextBox 340,126,100,21,.txtTmax
        TextBox 470,126,100,21,.txtTdel
        OKButton 180,175,120,28,.cmdOK
        CancelButton 360,175,110,28,.cmdCancel
    End Dialog
    On Error Resume Next
    mType = Val(IniString(IniSec$, "MeasType"))    ' 0 Reflectance  1 Transmittance
    Tmin = Val(IniString(IniSec$, "TempMin"))
    Tmax = Val(IniString(IniSec$, "TempMax"))
    If Tmax = 0 Then Tmax = 100
    Tdel = Val(IniString(IniSec$, "TempDel"))
    If Tdel = 0 Then Tdel = 20
    Desc = IniString(IniSec$, "Description")
    Dim dlg As UserDialog
    With dlg
        .MeasType = mType
        .txtDesc = Desc$
        .txtTmin = CStr(Tmin)
        .txtTmax = CStr(Tmax)
        .txtTdel = CStr(Tdel)
    End With
    On Error GoTo Cancelled
    Dialog dlg
    With dlg
        mType = .MeasType
        Desc$ = .txtDesc
        Tmin = Val(.txtTmin)
        Tmax = Val(.txtTmax)
        Tdel = Val(.txtTdel)
    End With
    WriteIniString IniSec$, "MeasType", CStr(mType)
    WriteIniString IniSec$, "Description", Desc$
    WriteIniString IniSec$, "TempMin", CStr(Tmin)
    WriteIniString IniSec$, "TempMax", CStr(Tmax)
    WriteIniString IniSec$, "TempDel", CStr(Tdel)
    On Error GoTo 0
    DoSamples Tmin, Tmax, Tdel
    MainActivate
    AxesDraw
    Replot

mK1000Quit:
    mK1000.StopAll  ' stop temperature controller (comment-out if not required)
    On Error Resume Next
    mK1000.Quit     ' close temperature control window
    DoEvents
    Set mK1000 = Nothing
    Exit Sub
Cancelled:
    MsgBox "mK1000 Scan procedure cancelled", vbInformation, Title
    GoTo mK1000Quit
End Sub

Sub DoSamples(ByVal Tmin, ByVal Tmax, ByVal Tdel)
    Dim iDat, iPlt, Temp, nDat, xDat(), yDat(), kCol, nCols, nRows, f$, t$, v
    Dim wMin, wMax, Wdel
    nCols = 2 + (Tmax - Tmin)/Tdel
    nRows = 2 + (ScanRange(1, 2) - ScanRange(1,1)) / ScanRange(1, 3)
    XLnew nRows, nCols, "Sample1"
    For Temp = Tmin To Tmax Step Tdel
        t$ = CStr(Temp) & ""
        kCol = kCol + 1
        StatusLabel "Setting T = " & t$
        SetAndWait Temp ' set temperature
        StatusLabel "Scanning T = " & t$
        AxesDraw
        Scan
        DoEvents
        Replot
        If kCol = 1 Then
            xDat = Spectrum_X
            nDat = UBound(xDat)
            XLwrite 1, 1, "Wave (nm)",,,, RGB(228, 228, 255)
            For iDat = 1 To nDat
                XLwrite iDat + 1, 1, xDat(iDat)
            Next iDat
            kCol = 2
        End If
        XLwrite 1, kCol, t$,,,, RGB(228, 228, 255)
        yDat = Spectrum_Y
        If TestMode Then
            For iDat = 1 To nDat
                yDat(iDat) = yDat(iDat) - Abs(Temp)/1000   ' vary the test columns
                If yDat(iDat) < 0 Then yDat(iDat) = 0
                XLwrite iDat + 1, kCol, 100 * yDat(iDat)   ' results in %
            Next iDat
            Spectrum_Y = yDat
        Else
            For iDat = 1 To nDat
                XLwrite iDat + 1, kCol, 100 * yDat(iDat)
            Next iDat
        End If
    Next Temp
    On Error Resume Next
    Kill Directory$ & "Test.xls"
    XLsave Directory$ & "Test.xls"
    XLclose
    DoEvents
    XLview Directory$ & "Test.xls"
End Sub

Private Sub SetAndWait(ByVal tSet!)
    Dim t!, t0!
    t0 = -999
    mK1000.HoldTemp tSet
    DoEvents
    Do
        t = mK1000.CurrentTemp()
        If Abs(t - tSet) < tDelta And Abs(t - t0) < tDeriv Then
            Exit Do     ' temperature reached, can exit Sub
        Else
            t0 = t
        End If
        Wait .01
        DoEvents
    Loop
End Sub

Private Function DlgFunc(DlgItem$, Action%, SuppValue&) As Boolean
    Select Case Action%
    Case 1 ' Dialog box initialization
        SetFont "optRefl", SuppValue
        SetFont "optTrns", SuppValue
        SetFont "lblTmax", SuppValue
        SetFont "lblTdel", SuppValue
        SetFont "lblDesc", SuppValue
        SetFont "lblTemp", SuppValue
        SetFont "txtDesc", SuppValue
        SetFont "lblTmin", SuppValue
        SetFont "lblTmax", SuppValue
        SetFont "lblTdel", SuppValue
        SetFont "txtTmin", SuppValue
        SetFont "txtTmax", SuppValue
        SetFont "txtTdel", SuppValue
        SetFont "cmdCancel", SuppValue
        SetFont "cmdOK", SuppValue
    Case 2 ' Value changing or button pressed
    Case 3 ' TextBox or ComboBox text changed
    Case 4 ' Focus changed
    Case 5 ' Idle
    Case 6 ' Function key
    End Select
End Function

Private Function SetFont(ByVal item$, ByVal SuppValue&)
    Dim hDC&, hWnd&, Height&
    Static k As Boolean
    If Not k Then
        hDC = GetWindowDC(0)
        Height = -9 * GetDeviceCaps(hDC,LOGPIXELSY) / 72   ' 9 point
        ReleaseDC 0, hDC
        hFont = CreateFontA(Height,0,0,0,300,0,0,0,0,0,0,0,0,"Verdana")
        k = True
    End If
    hWnd = GetDlgItem(SuppValue, DlgControlId(item$))
    SendMessageA hWnd, WM_SETFONT, hFont, 1
End Function

